uCalc Prefix "uCalc Define Func::"
   LoadLibrary(FileName As String) As Dword At ucAddr(uc_Func_LoadLibrary)
   GetProcAddress(hModule As Dword, ProcName As String) As Dword _
      At ucAddr(uc_Func_GetProcAddress)
uCalc Prefix ""

uCalc Syntax SetDLL {DLLName} ::= uc_Push(InputBuffer, _
   "uCalc Define Func: {DLLName}(Procedure As String) As Dword _
   = GetProcAddress(LoadLibrary('{DLLName}.DLL'), Procedure)")

SetDLL User32
SetDLL Kernel32
SetDLL GDI32
SetDLL Shell32
SetDLL OleAut32
SetDLL ShlWapi
'SetDLL OpenGL32
'SetDLL WinMM
'SetDLL WinSpool[.DRV]

uCalc Prefix "uCalc Define "
   Begin
      DataType: COORD
      {Var: x As Integer}
      {Var: y As Integer}
      TypeHandler: ucAddr(uc_User_Type)
   End
   
   Begin
      DataType: SMALL_RECT
      {Var: xLeft As Integer}
      {Var: xTop As Integer}
      {Var: xRight As Integer}
      {Var: xBottom As Integer}
      TypeHandler: ucAddr(uc_User_Type)
   End

   Begin
      DataType: CONSOLE_SCREEN_BUFFER_INFO
      {Var: dwSize As COORD}
      {Var: dwCursorPosition As COORD}
      {Var: wAttributes As Word}
      {Var: srWindow As SMALL_RECT}
      {Var: dwMaximumWindowSize As COORD}
      TypeHandler: ucAddr(uc_User_Type)
   End
uCalc Prefix ""

uCalc Prefix "uCalc Define Func:"
   CreateWindowEx(ByVal dwExStyle As Dword, ByRef lpClassName As LPCSTR, _
      ByRef lpWindowName As LPCSTR, ByVal dwStyle As DWORD, ByVal x As Long, _
      ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, _
      ByVal hWndParent As Dword, ByVal hMenu As Dword, _
      ByVal hInstance As Dword, ByVal lpParam As Dword) As Dword _
      At User32("CreateWindowExA")

   DestroyWindow(ByVal hWnd As Dword) As Long At User32("DestroyWindow")

   FillConsoleOutputCharacter(ByVal hConsoleOutput As Dword,                 _
      ByVal Character As Byte, ByVal nLength As Dword,                       _
      ByVal dwWriteCoord As COORD, ByRef lpNumberOfCharactersWritten As Dword) _
      As Long At Kernel32("FillConsoleOutputCharacterA")

   GetConsoleScreenBufferInfo(ByVal hConsoleOutput As Dword, _
      ByRef lpConsoleScreenBufferInfo As CONSOLE_SCREEN_BUFFER_INFO) As Long _
      At Kernel32("GetConsoleScreenBufferInfo")

   GetConsoleTitle(ByRef lpConsoleTitle As LPCSTR, ByVal nSize As Dword) _
      As Long At Kernel32("GetConsoleTitleA")

   GetDC(ByVal hWnd As Dword) As Dword At User32("GetDC")

   GetLargestConsoleWindowSize(ByVal hConsoleOutput As Dword) As Long _
      At Kernel32("GetLargestConsoleWindowSize")

   GetStdHandle(ByVal nStdHandle As Dword) As Dword At Kernel32("GetStdHandle")

   GetTickCount() As Dword At Kernel32("GetTickCount")

   LineTo(ByVal hdc As Dword, ByVal x As Long, ByVal y As Long) As Long At GDI32("LineTo")

   MessageBox(ByVal hWnd As Dword, ByRef lpText As LPCSTR, _
      ByRef lpCaption As LPCSTR, ByVal uType as Dword)     _
      As Long At User32("MessageBoxA")

   MoveToEx(ByVal hWnd As Dword, ByVal x As Long, ByVal y As Long, ByVal PointAddr As Dword) As Long At GDI32("MoveToEx")

   ReadConsole(ByVal hConsoleInput As Dword, ByRef lpBuffer As LPCSTR,       _
      ByVal nNumberOfCharsToRead As Long, ByRef lpNumberOfCharsRead As Long, _
      ByRef lpReserved As Long) As Long At Kernel32("ReadConsoleA")

   SetConsoleCursorPosition(ByVal hConsoleOutput As Dword, _
      ByVal CursorPosition As COORD) As Long               _
      At Kernel32("SetConsoleCursorPosition")

   SetConsoleMode(ByVal hConsoleHandle As Dword, ByVal dwMode As Dword) _
      At Kernel32("SetConsoleMode")

   SetConsoleTextAttribute(ByVal hConsoleOutput As Dword,  _
      ByVal vAttributes As Word) As Long At Kernel32("SetConsoleTextAttribute")

   SetConsoleTitle(ByRef lpConsoleTitle As LPCSTR) As Long _
      At Kernel32("SetConsoleTitleA")

   Sleep(ByVal dwMilliseconds As Dword) As Void At Kernel32("Sleep")

   ShellExecute(Hwnd As Dword, ByRef lpOperation As LPCSTR, _
      ByRef lpFile As LPCSTR, ByRef lpParams As LPCSTR,     _
      ByRef lpDirectory As LPCSTR, ByVal nShowCmd As Long)  _
      As DWORD At Shell32("ShellExecuteA")

   StrTrim(ByRef pszSource As LPCSTR, ByRef pszTrimChars As LPCSTR) As Long _
      At ShlWapi("StrTrimA")

   SysStringByteLen(ByVal BSTR As Dword) As Long At OleAut32("SysStringByteLen")

   WriteConsole(ByVal hConsoleOutput As Dword, ByRef lpBuffer As LPCSTR, _
      ByVal nNumberOfCharsToWrite As Long,                               _
      ByRef lpNumberOfCharsWritten As Long,                              _
      ByVal lpReservered As Long) As Long At Kernel32("WriteConsoleA")
uCalc Prefix ""

uCalc Define Var: _lpText As LPCSTR ~~ Size: 100

uCalc Prefix "uCalc Define Var:"
   ENABLE_PROCESSED_INPUT = 1
   ENABLE_LINE_INPUT      = 2
   ENABLE_ECHO_INPUT      = 4

   STD_INPUT_HANDLE       = -10
   STD_OUTPUT_HANDLE      = -11
   STD_ERROR_HANDLE       = -12

   StdIn  = GetStdHandle(STD_INPUT_HANDLE)
   StdOut = GetStdHandle(STD_OUTPUT_HANDLE)
   StdErr = GetStdHandle(STD_ERROR_HANDLE)
uCalc Prefix ""
